library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity FSMD is
  port( a        : in STD_LOGIC_VECTOR(3 downto 0);
        c, start : in STD_LOGIC;
        volumen  : out STD_LOGIC_VECTOR(11 downto 0);
        ready    : out STD_LOGIC);
end FSMD;

architecture Implementierung of FSMD is

signal a_unsigned: UNSIGNED(3 downto 0);
signal flaeche_unsigned: UNSIGNED(11 downto 0);
signal i_unsigned, n_unsigned : UNSIGNED(3 downto 0);
signal volumen_unsigned : UNSIGNED(11 downto 0);
signal zustand, zustand_next : STD_LOGIC_VECTOR(2 downto 0);


begin
   a_unsigned <= UNSIGNED(a);
   volumen   <= STD_LOGIC_VECTOR(volumen_unsigned);
	  
  
   Automat: process(zustand, start)
   begin
   
      case zustand is
       
         -- initialer Zustand
         when "000" =>
	    if (start = '1') then
	       volumen_unsigned <= "000000000000";
	       i_unsigned <= "0000";
	       ready <= '0';
	       zustand_next <= "001";
	    else
	       ready <= '1';
	       zustand_next <= zustand;
	    end if;
	     
         when "001" =>
	    if (i_unsigned = a_unsigned) then
	       zustand_next <= "000";
	       ready <= '1';
	    else
	       zustand_next <= "010";
	       n_unsigned <= "0000";
	       flaeche_unsigned <= "000000000000";
	    end if; 

         when "010" =>
	    if (n_unsigned = a_unsigned) then
	       volumen_unsigned <= volumen_unsigned + flaeche_unsigned;
	       i_unsigned <= i_unsigned + 1;
	       zustand_next <= "001";
	    else
	       zustand_next <= "011";
	    end if;
	       
         when "011" =>
	    flaeche_unsigned <= flaeche_unsigned + a_unsigned;
	    n_unsigned <= n_unsigned + 1;
	    zustand_next <= "010";
		 
         when others =>
	    zustand_next <= "000";
		 
      end case;

   end process;  
  
  next_state: process(c)
  begin
  
       -- warten auf steigende Taktflanke
       if c='1' then
             -- den neuen Zustand setzen
             zustand <= zustand_next;
       end if;
  end process;  
  
end Implementierung;








