
library IEEE;
use IEEE.std_logic_1164.all;

entity Eis is
  port (geld_50,geld_100,geld_200,will_eis_mini,will_eis_maxi,cancel,clock : IN STD_LOGIC;
        kein_50,kein_100,kein_200,mach_eis_mini,mach_eis_maxi: OUT STD_LOGIC);
end Eis;

architecture Behaviour of Eis is
  signal zustand, zustand_next : STD_LOGIC_VECTOR(2 downto 0);
begin
  
  Automat: process ( geld_50,geld_100,geld_200,will_eis_mini,will_eis_maxi,cancel )
  begin
  
       kein_50 <= '0';
       kein_100 <= '0';
       kein_200 <= '0';
       mach_eis_mini <= '0';
       mach_eis_maxi <= '0';
  
       case zustand is
       
            -- initialer Zustand, 0 DM eingeworfen
            when "000" => 
	         -- 50 Pfennige eingeworfen?
	         if (geld_50='1') then
		    zustand_next <= "001";
		    kein_200 <= '1';
		 end if;
		 -- 1 DM eingeworfen?
		 if (geld_100='1') then
		    zustand_next <= "010";
		    kein_200 <= '1';
		 end if;
		 -- 2 DM eingeworfen?
		 if (geld_200='1') then
		    zustand_next <= "100";
		    kein_50 <= '1';
		    kein_100 <= '1';
		    kein_200 <= '1';
		 end if;
	    
	    -- 0,50 DM sind eingeworfen
            when "001" =>
	         -- 50 Pfennige eingeworfen?
	         if (geld_50='1') then
		    zustand_next <= "010";
		    kein_200 <= '1';
		 end if;
		 -- 1 DM eingeworfen?
		 if (geld_100='1') then
		    zustand_next <= "011";
		    kein_100 <= '1';
		    kein_200 <= '1';
		 end if;
		 
            -- 1 DM ist eingeworfen
            when "010" =>
	         -- 50 Pfennige eingeworfen?
	         if (geld_50='1') then
		    zustand_next <= "011";
		    kein_200 <= '1';
		    kein_100 <= '1';
		 end if;
		 -- 1 DM eingeworfen?
		 if (geld_100='1') then
		    zustand_next <= "100";
		    kein_50 <= '1';
		    kein_100 <= '1';
		    kein_200 <= '1';
		 end if;
		 -- kleines Eis machen?
		 if (will_eis_mini = '1') then
		    zustand_next <= "000";
		    mach_eis_mini <= '1';
		 end if;
		 
            -- 1,50 DM sind eigeworfen
            when "011" =>
	         -- 50 Pfennige eingeworfen?
	         if (geld_50='1') then
		    zustand_next <= "100";
		    kein_200 <= '1';
		    kein_100 <= '1';
		    kein_50 <= '1';
		 end if;
		 
	    -- 2 DM sind eingeworfen
            when "100" =>
	         -- grosses Eis machen?
	         if (will_eis_maxi <= '1') then
		    zustand_next <= "000";
		    mach_eis_maxi <= '1';
		 end if;
		 
           when others =>
	      -- die Schattenausgangssignale zuruecksetzen
              -- zustand <= "000";
	      zustand_next <="000";

	      kein_50 <= '0';
	      kein_100 <= '0';
	      kein_200 <= '0';
	      mach_eis_mini <= '0';
	      mach_eis_maxi <= '0';       
		 
       end case;
   
       -- den Abbruch gesondert abfragen. Hier setzen wir den Automaten in den
       -- initialen Zustand zurueck.
       if (cancel='1') then
            zustand_next <= "000";

	    -- die Schattenausgangssignale zuruecksetzen
	    kein_50 <= '0';
	    kein_100 <= '0';
	    kein_200 <= '0';
	    mach_eis_mini <= '0';
	    mach_eis_maxi <= '0';       
       end if;

  end process;  
  
  next_state: process
  begin
  
       -- warten auf steigende Taktflanke
       wait until (clock'event);
       
          if (clock='1') then 
             -- den neuen Zustand setzen
             zustand <= zustand_next;
	  end if;
  
  end process;  
  
end Behaviour;
